﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using xserver;

namespace ClusteringPlanWeek
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            runSample();
        }

        public void runSample()
        {
            WeekPlan plan = runClusterSample();
            if (plan != null)
                runMap(plan);
        }

        public WeekPlan runClusterSample() {
		    // Step 1: Instantiate remote interface for xCluster
		    XClusterWSService client = new XClusterWSService();

		    // Step 2.1: Set CallerContext for adding log information into your basic
		    // response logs.
		    CallerContext cxt = new CallerContext();
		    cxt.log1 = "Plan Week";
		    // Step 2.2 Set CallerContext properties to define profile and CoordFormat
		    CallerContextProperty props1 = new CallerContextProperty
            {
                key = "Profile",
                value = "default"
            };
		    CallerContextProperty props2 = new CallerContextProperty
            {
                key = "CoordFormat",
                value = "PTV_MERCATOR"
            };
		    CallerContextProperty[] properties = new CallerContextProperty[] { props1, props2 };
		    cxt.wrappedProperties = properties;

		    // Step 3: create object orders which contain a list of cluster orders
		    // (corresponds to one visit)
		    List<String> orders = new List<String>();
		    orders = loadOrder();
		    int max = orders.Count;
		    WeekOrder[] weekOrders = new WeekOrder[max];

		    int index = 0;
		    foreach (String s in orders) {
                String[] splitString = s.Split(';');

			    int oid = Convert.ToInt32(splitString[0]);
			    int x = Convert.ToInt32(splitString[1]);
			    int y = Convert.ToInt32(splitString[2]);
			    int wmax = Convert.ToInt32(splitString[3]);
			    String[] vecVisitsStrings = splitString[4].Split('~');
                List<int> vecVisits = new List<int>();
                foreach (String s1 in vecVisitsStrings) 
                {
                    vecVisits.Add(Convert.ToInt32(s1));
                }
                

			    // Define location
			    Location location = new Location();
			    location.x = x;
			    location.y = y;

			    // Define validity
			    WeekValidity validities = new WeekValidity();
			    validities.day1 = true;
			    validities.day2 = true;
			    validities.day3 = true;
			    validities.day4 = true;
			    validities.day5 = true;
			    validities.day6 = false;
			    validities.day7 = false;

			    // Define weekday patterns

			    WeekValidity[] weekdayPatterns;

			    if (wmax == 1) {
				    WeekValidity weekdayPattern1 = new WeekValidity();
				    weekdayPattern1.day1 = true;
				    weekdayPattern1.day2 = false;
				    weekdayPattern1.day3 = false;
				    weekdayPattern1.day4 = false;
				    weekdayPattern1.day5 = false;
				    weekdayPattern1.day6 = false;
				    weekdayPattern1.day7 = false;

				    WeekValidity weekdayPattern2 = new WeekValidity();
				    weekdayPattern2.day1 = false;
				    weekdayPattern2.day2 = true;
				    weekdayPattern2.day3 = false;
				    weekdayPattern2.day4 = false;
				    weekdayPattern2.day5 = false;
				    weekdayPattern2.day6 = false;
				    weekdayPattern2.day7 = false;

				    WeekValidity weekdayPattern3 = new WeekValidity();
				    weekdayPattern3.day1 = false;
				    weekdayPattern3.day2 = false;
				    weekdayPattern3.day3 = true;
				    weekdayPattern3.day4 = false;
				    weekdayPattern3.day5 = false;
				    weekdayPattern3.day6 = false;
				    weekdayPattern3.day7 = false;

				    WeekValidity weekdayPattern4 = new WeekValidity();
				    weekdayPattern4.day1 = false;
				    weekdayPattern4.day2 = false;
				    weekdayPattern4.day3 = false;
				    weekdayPattern4.day4 = true;
				    weekdayPattern4.day5 = false;
				    weekdayPattern4.day6 = false;
				    weekdayPattern4.day7 = false;

				    WeekValidity weekdayPattern5 = new WeekValidity();
				    weekdayPattern5.day1 = false;
				    weekdayPattern5.day2 = false;
				    weekdayPattern5.day3 = false;
				    weekdayPattern5.day4 = false;
				    weekdayPattern5.day5 = true;
				    weekdayPattern5.day6 = false;
				    weekdayPattern5.day7 = false;

				    weekdayPatterns = new WeekValidity[] { weekdayPattern1, weekdayPattern2, weekdayPattern3, weekdayPattern4,
						    weekdayPattern5 };
			    } else {
				    WeekValidity weekdayPattern1 = new WeekValidity();
				    weekdayPattern1.day1 = true;
				    weekdayPattern1.day2 = false;
				    weekdayPattern1.day3 = true;
				    weekdayPattern1.day4 = false;
				    weekdayPattern1.day5 = false;
				    weekdayPattern1.day6 = false;
				    weekdayPattern1.day7 = false;

				    WeekValidity weekdayPattern2 = new WeekValidity();
				    weekdayPattern2.day1 = false;
				    weekdayPattern2.day2 = true;
				    weekdayPattern2.day3 = false;
				    weekdayPattern2.day4 = true;
				    weekdayPattern2.day5 = false;
				    weekdayPattern2.day6 = false;
				    weekdayPattern2.day7 = false;

				    WeekValidity weekdayPattern3 = new WeekValidity();
				    weekdayPattern3.day1 = false;
				    weekdayPattern3.day2 = false;
				    weekdayPattern3.day3 = true;
				    weekdayPattern3.day4 = false;
				    weekdayPattern3.day5 = true;
				    weekdayPattern3.day6 = false;
				    weekdayPattern3.day7 = false;

				    WeekValidity weekdayPattern4 = new WeekValidity();
				    weekdayPattern4.day1 = false;
				    weekdayPattern4.day2 = true;
				    weekdayPattern4.day3 = false;
				    weekdayPattern4.day4 = false;
				    weekdayPattern4.day5 = true;
				    weekdayPattern4.day6 = false;
				    weekdayPattern4.day7 = false;

				    WeekValidity weekdayPattern5 = new WeekValidity();
				    weekdayPattern5.day1 = true;
				    weekdayPattern5.day2 = false;
				    weekdayPattern5.day3 = false;
				    weekdayPattern5.day4 = true;
				    weekdayPattern5.day5 = false;
				    weekdayPattern5.day6 = false;
				    weekdayPattern5.day7 = false;

				    WeekValidity weekdayPattern6 = new WeekValidity();
				    weekdayPattern6.day1 = true;
				    weekdayPattern6.day2 = false;
				    weekdayPattern6.day3 = false;
				    weekdayPattern6.day4 = false;
				    weekdayPattern6.day5 = true;
				    weekdayPattern6.day6 = false;
				    weekdayPattern6.day7 = false;

				    weekdayPatterns = new WeekValidity[] { weekdayPattern1, weekdayPattern2, weekdayPattern3, weekdayPattern4,
						    weekdayPattern5, weekdayPattern6 };
			    }

			    // Set assignmentRules
			    WeekRules assignmentRules = new WeekRules();
			    assignmentRules.validities = validities;
			    assignmentRules.visitsPerWeek = wmax;
			    assignmentRules.wrappedWeekdayPatterns = weekdayPatterns;

			    // Set quantity to weekVisits
			    WeekVisit[] weekVisits = new WeekVisit[wmax];
			    int oindex = 0;
			    foreach (int visit in vecVisits) {
				    int quantity = visit;
				    WeekVisit weekVisit = new WeekVisit();
				    weekVisit.quantity = quantity;
				    weekVisits[oindex] = weekVisit;
				    oindex++;
			    }

			    WeekOrder order = new WeekOrder
                {
                    orderID = oid,
                    loc = location,
                    orderFixed = false,
                    wrappedVisits = weekVisits,
                    visitSplits = 2,
                    visitSplitsSpecified = true,
                    assignmentRules = assignmentRules
                };

			    weekOrders[index] = order;
			    index++;
		    }

		    // Step 4: Define number of clusters and specific parameters
		    WeekParams weekParams = new WeekParams
            {
                costPeriodMinute = 120,
                costPeriodMinuteSpecified = true,
                costDistanceKm = 360,
                costDistanceKmSpecified = true,
                constructionStep = true, 
                constructionStepSpecified = true,
                improvementStep = true,
                improvementStepSpecified = true,
                postOptStep = true,
                postOptStepSpecified = true,
                weekdayCount = 5,
            };

		    try 
            {
			    // Step 5: Call method planWeek
			    WeekPlan weekPlan = client.planWeek(weekOrders, weekParams, cxt);

			    createTableOutputWeekOrder(weekPlan);
			    createTableWeekdayCluster(weekPlan);
                return weekPlan;
		    } 
            catch (Exception e) 
            {
			    // TODO: exception handling
                return null;
		    }
	    }

        private void createTableOutputWeekOrder(WeekPlan weekPlan) {
		    List<OrderTableEntry> weekOrders = new List<OrderTableEntry>();

		    foreach (OutputWeekOrder order in weekPlan.wrappedOrders) {
                String visits = "";
                foreach (OutputWeekVisit visit in order.wrappedVisits)
                {
                    int wd = visit.weekday;
                    String weekday = "";

                    if (wd == 1)
                    {
                        weekday = "Monday";
                    }
                    else if (wd == 2)
                    {
                        weekday = "Tuesday";
                    }
                    else if (wd == 3)
                    {
                        weekday = "Wednesday";
                    }
                    else if (wd == 4)
                    {
                        weekday = "Thursday";
                    }
                    else
                    {
                        weekday = "Friday";
                    }
                    visits = visits + weekday + ";";
                }
                
                OrderTableEntry row = new OrderTableEntry 
                {
                    orderID = order.orderID,
                    visits = visits
                };

                weekOrders.Add(row);
		    }
            gridOrders.ItemsSource = weekOrders;
	    }

        private void createTableWeekdayCluster(WeekPlan weekPlan) {
		    List<WeekdayTableEntry> weekClusters = new List<WeekdayTableEntry>();

		    foreach (WeekdayCluster cluster in weekPlan.wrappedClusters) {
			    WeekdayTableEntry row = new WeekdayTableEntry
                {
                    load = cluster.load,
                    servicePeriod = cluster.quantity,
                    target = cluster.target,
                    visitCount = cluster.visitCount,
                    weekday = cluster.weekday
                };
                weekClusters.Add(row);
		    }

		    // visualize orders assigned to their clusters
		    gridWeekdays.ItemsSource = weekClusters;
	    }

        private static List<String> loadOrder()
            {
                List<String> list = new List<String>();
                // orderId, X, Y, number of week visits, visits values (service period(s)
                // and day(s))
                list.Add("101;671006;6382294;1;90");
                list.Add("102;681812;6375071;1;120");
                list.Add("103;682676;6388154;2;90~80");
                list.Add("104;675000;6380000;1;60");
                list.Add("105;679143;6374455;1;90");
                list.Add("106;684621;6374703;2;180~160");
                list.Add("107;684659;6372947;1;90");
                list.Add("108;683151;6371248;1;30");
                list.Add("109;685669;6371954;2;45~70");
                list.Add("110;683974;6369193;1;60");
                list.Add("111;683000;6366903;1;90");
                list.Add("112;678763;6367800;2;120~90");
                list.Add("113;681397;6369670;1;105");
                list.Add("114;678400;6370854;1;90");
                list.Add("115;674779;6373188;2;60~30");
                list.Add("116;678149;6380180;1;45");
                list.Add("117;680440;6381326;1;30");
                list.Add("118;665627;6378195;2;90~100");
                list.Add("119;687472;6386122;1;180");
                list.Add("120;666773;6381020;1;120");
                list.Add("121;687136;6382563;2;60~50");
                list.Add("122;665642;6382471;1;30");
                list.Add("123;665627;6386365;1;45");
                list.Add("124;672957;6388121;2;60~20");
                list.Add("125;677004;6388121;1;75");
                list.Add("126;682578;6384074;1;90");
                list.Add("127;687540;6379111;2;105~120");
                list.Add("128;681661;6384838;1;120");
                list.Add("129;687388;6385754;1;135");
                list.Add("130;685937;6388121;2;150~110");

                return list;
            }

            private CallerContext setCallerContext()
            {
                CallerContext cxt = new CallerContext();
                cxt.log1 = "Plan Week";
                // set CallerContext properties to define profile and CoordFormat
                CallerContextProperty props1 = new CallerContextProperty
                {
                    key = "Profile",
                    value = "default"
                };
                CallerContextProperty props2 = new CallerContextProperty
                {
                    key = "CoordFormat",
                    value = "PTV_MERCATOR"
                };
                CallerContextProperty[] properties = new CallerContextProperty[] { props1, props2 };
                cxt.wrappedProperties = properties;
                return cxt;
            }

            private static ImageInfo setImageInfo()
            {
                ImageInfo imageInfo = new ImageInfo
                {
                    format = ImageFileFormat.PNG,
                    height = 530,
                    width = 787,
                    imageParameter = ""
                };
                return imageInfo;
            }

            private static MapParams setMapParams()
            {
                MapParams mapParams = new MapParams
                {
                    showScale = true,
                    useMiles = false
                };
                return mapParams;
            }

            private static CustomLayer setCustomLayer()
            {
                CustomLayer customLayer = new CustomLayer
                {
                    centerObjects = true,
                    drawPriority = 25000,
                    name = "ObjectLayer",
                    objectInfos = ObjectInfoType.REFERENCEPOINT,
                    visible = true
                };
                return customLayer;
            }

            private void runMap(WeekPlan weekPlan) 
            {
		        // Step 1: Initialize xmap client
		        XMapWSService xmapClient = new XMapWSService();

		        // Step 2: Set CallerContext
		        CallerContext cxt = setCallerContext();

		        // Step 3: Create imageInfo and set relevant attributes
		        ImageInfo imageInfo = setImageInfo();

		        // Step 4: Realize object mapParams showing scale without use of miles.
		        MapParams mapParams = setMapParams();

		        // Step 5: Define boolean value including image in response
		        bool includeImageInResponse = false;

		        // Step 6: Initialize customLayer with the relevant settings
		        CustomLayer customLayer = setCustomLayer();

		        // Step 7.1: Create bitmap arrays per weekday
		        for (int i = 0; i < 5; i++) {
			        int max = weekPlan.wrappedClusters[i].visitCount;
			        Bitmap[] bitmapArray = new Bitmap[max];
			        List<String> orders = loadOrder();
			        int index = 0;

			        foreach (OutputWeekOrder weekOrder in weekPlan.wrappedOrders) {

				        // Step 7.2: Define weekdays
				        foreach (OutputWeekVisit outputWeekVisit in weekOrder.wrappedVisits) {

					        // Step 7.3: Get location from order and fill bitmapArray
					        if (outputWeekVisit.weekday == i + 1) {
						        int oid = weekOrder.orderID;
						        double x = 0.0;
						        double y = 0.0;
						        xserver.Point point = new  xserver.Point();
						        PlainPoint plainPoint = new PlainPoint();

						        foreach (String s in orders) {
                                    String[] splitString = s.Split(';');
							        int orderIndex = Convert.ToInt32(splitString[0]);
							        if (orderIndex == oid) {
								        x = Convert.ToInt32(splitString[1]);
								        y = Convert.ToInt32(splitString[2]);
								        plainPoint.x = x;
								        plainPoint.y = y;
								        point.point = plainPoint;
								        bitmapArray[index] = new Bitmap();
								        bitmapArray[index].position = point;

								        if (i == 0) {
									        bitmapArray[index].name = "flagblue.bmp";
									        bitmapArray[index].descr = "First cluster";
								        } else if (i == 1) {
									        bitmapArray[index].name = "flagred.bmp";
									        bitmapArray[index].descr = "Second cluster";
								        } else if (i == 2) {
									        bitmapArray[index].name = "flaggreen.bmp";
									        bitmapArray[index].descr = "Third cluster";
								        } else if (i == 3) {
									        bitmapArray[index].name = "n_marker1.bmp";
									        bitmapArray[index].descr = "Forth cluster";
								        } else {
									        bitmapArray[index].name = "n_marker2.bmp";
									        bitmapArray[index].descr = "Fifth cluster";
								        }

								        index++;
								        break;
							        }
						        }
					        }
				        }
			        }
			        // Step 8.1: Set bitmapOptions
			        BitmapOptions bitmapOptions = new BitmapOptions();
                    PlainPoint referencePoint = new PlainPoint { x = 20, y = 20 } ;
			        bitmapOptions.referencePoint = referencePoint;
			        bitmapOptions.transparencyColor = new xserver.Color { red = 255, green = 255, blue = 255 } ;

			        // Step 8.2: Add bitmapArray and bitmapOptions into bitmaps
			        Bitmaps[] bitmaps = new Bitmaps[] { new Bitmaps{ wrappedBitmaps = bitmapArray, options = bitmapOptions} };
			        customLayer.wrappedBitmaps = bitmaps;

			        // Step 9: Put customLayer into layers
			        Layer[] layers = new Layer[] { customLayer };

			        try {
				        // Step 10: Return map object with its characteristics
				        Map map = xmapClient.renderMap(null, mapParams, imageInfo, layers, includeImageInResponse, cxt);

				        // Step 11: Retrieve icon
                        String imageUrl = "http://" + map.image.url;
                        // Create BitmapImage
                        BitmapImage image = new BitmapImage();

                        // Display BitmapImage
                        image.BeginInit();
                        image.UriSource = new Uri(imageUrl);
                        image.EndInit();
                        switch (i)
                        {
                            case 0: { img1.Source = image; break; }
                            case 1: { img2.Source = image; break; }
                            case 2: { img3.Source = image; break; }
                            case 3: { img4.Source = image; break; }
                            case 4: { img5.Source = image; break; }
                        }

			        } catch (Exception e) {
				        // proper exception handling: see API for PTV's exception handling!
			        }

		    }
	    }
    }

    public class OrderTableEntry
    {
        public int orderID { get; set; }
        public String visits { get; set; }
    }

    public class WeekdayTableEntry
    {
        public double load { get; set; }
        public double servicePeriod { get; set; }
        public double target { get; set; }
        public int visitCount { get; set; }
        public int weekday { get; set; }
    }
}
