﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DimaCalculateDistanceTable.XDima;

namespace DimaCalculateDistanceTable
{
    class Program
    {
        static void Main(string[] args)
        {
            runSample();
        }
        private static void runSample()
        {
            // Step 1: Initialize PTV xDima client
            XDimaWSService xDimaClient = new XDimaWSService();

            // Step 2: Set the unique dima ID to catch the correct dima profile.
            int dimaID = 1001;

            // Step 3.1: Define 5 locations according to the dima profile.
            // Location A
            Location location_1 = new Location();
            int x1 = 681108;
            int y1 = 6371953;
            location_1.x = x1;
            location_1.y = y1;

            // Location B
            Location location_2 = new Location();
            int x2 = 681379;
            int y2 = 6372672;
            location_2.x = x2;
            location_2.y = y2;

            // Location C
            Location location_3 = new Location();
            int x3 = 681722;
            int y3 = 6372326;
            location_3.x = x3;
            location_3.y = y3;

            // Location D
            Location location_4 = new Location();
            int x4 = 682355;
            int y4 = 6372266;
            location_4.x = x4;
            location_4.y = y4;

            // Location E
            Location location_5 = new Location();
            int x5 = 681936;
            int y5 = 6371800;
            location_5.x = x5;
            location_5.y = y5;

            // Step 4.2: Add all locations into array locations
            Location[] locations = new Location[] { location_1, location_2, location_3, location_4, location_5 };

            try
            {
                // Step 5: Call method calculateDistanceTable()
                Console.WriteLine("Calculating Dima is in progress...");
                xDimaClient.calculateDistanceTable(dimaID, locations, null);
                Console.WriteLine("Dima <ID=1001> is calculated. Export Dima afterwards to receive the corressponding distances and periods.");
            }
            catch (Exception e)
            {
                // TODO: proper exception handling
            } 
        }
    }
}
