﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using DimaGetProfile.XDima;

namespace DimaGetProfile
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            runSample();
        }

        private void runSample()
        {
            List<DimaTableEntry> table = new List<DimaTableEntry>();
            runDimaSample(ref table);
            gridDima.ItemsSource = table;
        }

        private List<DimaTableEntry> runDimaSample(ref List<DimaTableEntry> rows) {
		    // Step 1: Instantiate xDima client.
            XDimaWSService xDimaClient = new XDimaWSService();

		    // Step 2: Set existing dimaID or zero
		    //int dimaID = 0;
		    int dimaID = 1001;

            try
            {
                // Step 3: Call method getDimaProfile()
                DimaProfileInfo[] dimaProfileInfos = xDimaClient.getDimaProfile(dimaID, null);

                // Step 4: Create result table with the corresponding output.
                if (dimaProfileInfos[0] != null)
                {
                    for (int i = 0; i < dimaProfileInfos.Length; i++)
                    {
                        DimaTableEntry row = new DimaTableEntry
                        {
                            dimaID = dimaProfileInfos[i].dimaID,
                            vType = dimaProfileInfos[i].dimaProfile.vehicleType.ToString(),
                            maxLoc = dimaProfileInfos[i].dimaProfile.maxLocationCount,
                            speedTable = dimaProfileInfos[i].dimaProfile.speedTable,
                            opt = dimaProfileInfos[i].dimaProfile.optimization,
                            ferryMalus = dimaProfileInfos[i].dimaProfile.ferryMalus,
                            tollMalus = dimaProfileInfos[i].dimaProfile.tollRoadMalus,
                            rampMalus = dimaProfileInfos[i].dimaProfile.rampMalus,
                            linkType = dimaProfileInfos[i].dimaProfile.linkType.ToString(),
                            routeType = dimaProfileInfos[i].dimaProfile.routingType.ToString()
                        };
                        rows.Add(row);
                    }
                }
                else
                {
                    //No dima profile infos found
                }
            }
            catch (Exception e)
            {
                // TODO: proper exception handling
            }
		    return rows;
	    }
    }

    public class DimaTableEntry
    {
        public int dimaID {get; set;}
        public String vType {get; set;}
        public int maxLoc {get; set;}
        public String speedTable {get; set;}
        public short opt {get; set;}
        public short ferryMalus { get; set; }
        public short tollMalus { get; set; }
        public short rampMalus { get; set; }
        public String linkType {get; set;}
        public string routeType {get; set;}
    }
}
