﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DimaSetDistPeriod.XDima;

namespace DimaSetDistPeriod
{
    class Program
    {
        static void Main(string[] args)
        {
            runSample();
        }
        
        private static void runSample()
        {
            // Step 1: Initialize PTV xDima client
		    XDimaWSService xDimaClient = new XDimaWSService();

		    // Step 2: Set the unique dima ID to catch the correct dima profile.
		    int dimaID = 1001;

		    // Step 3: Define 2 relations according to the existing location lists. Add them to array relationValues.
		    Location startLocation = new Location();
		    int x1 = 681108;
		    int y1 = 6371953;
		    startLocation.x = x1;
		    startLocation.y = y1;

		    Location destinationLocation = new Location();
		    int x2 = 681379;
		    int y2 = 6372672;
		    destinationLocation.x = x2;
		    destinationLocation.y = y2;

		    RelationValue relationValue1 = new RelationValue();
		    DistPeriod distPeriod1 = new DistPeriod();
		    distPeriod1.dist = 99999;
		    distPeriod1.period = 5555;
		    relationValue1.distPeriod = distPeriod1;
		    Relation relation_1 = new Relation();
		    relation_1.startLocation = startLocation;
		    relation_1.destinationLocation = destinationLocation;
		    relationValue1.relation = relation_1;
				
		    RelationValue relationValue2 = new RelationValue();
		    DistPeriod distPeriod2 = new DistPeriod();
		    distPeriod2.dist = 88888;
		    distPeriod2.period = 4444;
		    relationValue2.distPeriod = distPeriod2;
		    Relation relation_2 = new Relation();
		    relation_2.startLocation = destinationLocation;
		    relation_2.destinationLocation = startLocation;
		    relationValue2.relation = relation_2;

		    RelationValue[] relationValues = new RelationValue[] {relationValue1, relationValue2};
		
		    try 
            {
			    // Step 5: Call method setDistPeriod()
			    Console.WriteLine("Start to modify distance and period of relations...");
			    xDimaClient.setDistPeriod(dimaID, relationValues, null);
			    Console.WriteLine("Dima <ID=1001> is used for modification. Export Dima afterwards to evaluate the altered distances and periods.");
		    } 
            catch (Exception e) 
            {
			    // TODO: proper exception handling
		    } 
        }
    }
}
