﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GeocodingfindAddresses.XLocate;

namespace GeocodingfindAddresses
{
    class Program
    {
        static void Main(string[] args)
        {
            // Step 1: Instantiate XLocate client
            XLocateWSService client = new XLocateWSService();

            // Step 2.1: Set CallerContext for adding log information into your basic response logs.
            CallerContext context = new CallerContext();
            context.log1 = "Geocoding with multiple addresses";

            // Step 2.2 Set CallerContext properties to define profile and CoordFormat
            CallerContextProperty prop1 = new CallerContextProperty();
            prop1.key = "Profile";
            prop1.value = "default";
            CallerContextProperty prop2 = new CallerContextProperty();
            prop2.key = "CoordFormat";
            prop2.value = "PTV_MERCATOR";
            CallerContextProperty[] props = new CallerContextProperty[] { prop1, prop2 };
            context.wrappedProperties = props;

            // Step 3: Create address objects and array of addresses
            Address addr1 = new Address();
            addr1.country = "L";
            addr1.postCode = "1856";
            addr1.city = "Luxemburg";
            addr1.street = "Rue Evrard Ketten";

            Address addr2 = new Address();
            addr2.country = "L";
            addr2.postCode = "1856";
            addr2.city = "Luxemburg";
            addr2.street = "Rue Jean Soupert";

            Address[] addresses = new Address[] { addr1, addr2 };
            try
            {
                // Step 4: Get address responses, pass the CallerContext as a parameter
                AddressResponse[] responses = client.findAddresses(addresses, null, null, null, context);

                // Step 5: Output the results to the console
                for (int i = 0; i < responses.Length; i++)
                {
                    foreach (ResultAddress ra in responses[i].wrappedResultList)
                    {
                        Console.WriteLine(
                            String.Format("Found {0}~{1}~{2}~{3} at location: x={4} y={5}",
                                ra.country, ra.postCode, ra.city, ra.street, ra.coordinates.point.x, ra.coordinates.point.y)
                        );
                    }
                }
                Console.WriteLine("Press any key to exit...");
                Console.ReadLine();
            }
            catch (Exception e)
            {
                //TODO: proper exception handling
            }
        }
    }
}
