﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MappingWithBoundingBox.XMap;

namespace MappingWithBoundingBox
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            runSample();
        }
        public void runSample()
        {
            // step 1:
            // instantiate remote interface for xMap
            XMapWSService client = new XMapWSService();

            // Step 2.1: define upper left coordinate of the bounding box
            MappingWithBoundingBox.XMap.Point leftTop = new MappingWithBoundingBox.XMap.Point();
            PlainPoint plainPointLeftTop = new PlainPoint { x = 677712.4829360023, y = 6378309.416843999 };
            leftTop.point = plainPointLeftTop;

            // Step 2.2: define lower right coordinate of the bounding box
            MappingWithBoundingBox.XMap.Point rightBottom = new MappingWithBoundingBox.XMap.Point();
            PlainPoint plainPointRightBottom = new PlainPoint { x = 693103.0205360018, y = 6366766.513643999 };
            rightBottom.point = plainPointRightBottom;

            // Step 2.3: instantiate boundingBox and use the proper corners.
            BoundingBox boundingBox = new BoundingBox();
            boundingBox.leftTop = leftTop;
            boundingBox.rightBottom = rightBottom;

            // Step 3: set properties for class imageInfo 
            ImageInfo imageInfo = new ImageInfo();
            imageInfo.height = 240;
            imageInfo.width = 320;
            imageInfo.imageParameter = "";

            // Step 4: set scale and avoid miles
            MapParams mapParams = new MapParams();
            mapParams.showScale = true;
            mapParams.useMiles = false;

            // Step 5: don't include image in response
            bool includeImageInResponse = false;

            try
            {
                // Step 6: call renderMapBoundingBox and return a valid object map.
                Map map = client.renderMapBoundingBox(boundingBox, mapParams, imageInfo, null, includeImageInResponse, null);

                // Step 7: retrieve and display the image
                String imageUrl = "http://" + map.image.url;
                // Create BitmapImage
                BitmapImage bitmapImage = new BitmapImage();

                // Display BitmapImage
                bitmapImage.BeginInit();
                bitmapImage.UriSource = new Uri(imageUrl);
                bitmapImage.EndInit();

                img1.Source = bitmapImage;
            }
            catch (Exception e)
            {
                // TODO proper exception handling
            }
        }
    }
}
