﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using xserver;

namespace Geometry
{
    class PolygonCentroid
    {
        public xserver.Point calculateCentroid(List<Location> polygon)
        {
            xserver.Point centroid = new xserver.Point();
            double x = 0, y = 0;

            double area = calculatePolygonArea(ref polygon);

            for (int i = 0; i < polygon.Count; i++)
            {
                xserver.PlainPoint p, q;
                if (i == polygon.Count - 1)
                {
                    p = polygon[i].coordinate.point;
                    q = polygon[0].coordinate.point;
                }
                else
                {
                    p = polygon[i].coordinate.point;
                    q = polygon[i + 1].coordinate.point;
                }
                x += (p.x + q.x) * (p.x * q.y - q.x * p.y);
                y += (p.y + q.y) * (p.x * q.y - q.x * p.y);
            }
            centroid.point = new PlainPoint { x = x / (6 * area), y = y / (6 * area) };
            return centroid;
        }

        private double calculatePolygonArea(ref List<Location> polygon)
        {
            double area = 0;
            for (int i = 0; i < polygon.Count; i++)
            {
                xserver.PlainPoint p, q;
                if (i == polygon.Count - 1)
                {
                    p = polygon[i].coordinate.point;
                    q = polygon[0].coordinate.point;
                }
                else
                {
                    p = polygon[i].coordinate.point;
                    q = polygon[i + 1].coordinate.point;
                }
                area += p.x * q.y - q.x * p.y;
            }
            return area / 2;
        }
    }
}
